<?php

/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    Authorization
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.net/license/
 * @version    $Id: Edit.php 8412 2011-02-08 23:24:28Z john $
 * @author     John
 */

/**
 * @category   Application_Core
 * @package    Authorization
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.net/license/
 */
class Topcmmchat_Form_Admin_Settings_Edit extends Engine_Form
{

	protected $_moderator;
	protected $view;

  protected $_public;

  public function setModerator($moderator)
  {
    $this->_moderator = (bool) $moderator;
    return $this;
  }

  public function isModerator()
  {
    return (bool) $this->_moderator;
  }

  public function setPublic($public)
  {
    $this->_public = (bool) $public;
    return $this;
  }

  public function isPublic()
  {
    return (bool) $this->_public;
  }


  public function init()
  {
  	$table = new engine4_chat_topcmm();
//    parent::init()
//	$this->loadDefaultDecorators();
//    $this->getDecorator('Description')->setOptions(array('tag' => 'h4', 'placement' => 'PREPEND'));
//
//    // Prepare user levels
//    $levelOptions = array();
//    foreach( Engine_Api::_()->getDbtable('topcmm', 'chat')->fetchAll() as $level ) {
//      $levelOptions[$level->level_id] = $level->getTitle();
//    }


    //getchatsettings
    $db = $table->getAdapter();
	$where = $db->quoteInto('id = ?', '1');
	$this->view->row = $row = $table->fetchRow($where);
	$chatfun = new Topcmmchat_Controller_Action_Helper_ChatFun();
	$this->view->valid = $valid =  $chatfun->getValid($row);
    
    // Add submit
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true,
      'order' => 100000,
    ));


    // My stuff
    $this
        ->setTitle('Chat Settings')
        ->setDescription("Change your choice, in order to new Settings.Change your choice, in order to new Settings.Change your choice, in order to new SettingsChange your choice, in order to new Settings");

    // Element: fc_extendserver
      $this->addElement('Radio', 'fc_extendserver', array(
        'label' => 'Chat Server Mode:',
        'multiOptions' => array(
          '0' => 'Chat Server Host By Own',
          '1' => 'Chat Server Host By 123 Flash Chat',
          '2' => 'Chat Server Host By 123 Flash Chat For Free',
        ),
       	'onclick' => 'javascript:serverChange(this.value)',
       	'value' => $row->fc_extendserver,
      ));
      
      $this->addElement('Text','tip0',array(
      		'label'=>'Note',
      		'description'=>'Please download and install 123FlashChat first: http://www.123flashchat.com/download.html,
				and set Chat Client Location to: http://<your chat server domain or ip>:35555/',
      		'style' => "display:none;",
      		'allowEmpty' => true,
      		'required' => false,
      ));
      $this->addElement('Text','tip1',array(
      		'label'=>'Note',
      		'description'=>'For paid host, please set the Chat Client Location like this, for example: http://host71200.123flashchat.com/socialengine/, Buy host here:http://www.123flashchat.com/host.html,
				For trial host, please setup Chat Client Location like this: http://trial.123flashchat.com/yourhostname,
				Just replace "yourhostname" to the real one when you applied, Apply trial host here:http://www.123flashchat.com/host/apply.php',
      		'style' => "display:none;",
      		'allowEmpty' => true,
      		'required' => false,
      ));
      $this->addElement('Text','tip2',array(
      		'label'=>'Note',
      		'description'=>'This chat server mode aims at testing the basic functions, only supported 1 room, no video chat function, and also you don\'t have the administrator permission of entering this chat room, you can select the mode 1 or 2 to get the full functions and control your chat room.',
      		'style' => "display:none;",
      		'allowEmpty' => true,
      		'required' => false,
      ));
      
	//Element: Notice
      $this->addElement('Text', 'notice', array(
        'label' => 'Are you read me?',
        'description' => 'It is highly recommended to copy the chat client folder and files to your web server to reduce chat server load. For example, copy <123flashchat server installed directory>/client/ to <Your web root directory>/chat/, and configure "Chat Client Location" to http://www.yourdomain.com/chat/(i.e., /chat/) accordingly.',
      	//'style' => "display:none;",
      )
      );

     //Element: Integration URL
     $this->addElement('Text', 'intergration_url', array(
     		'label' => 'Integration URL:',
     		'description' => 'To integrate users for auto-login to chat, please open the Chat Admin Panel, then System Settings > Integration Panel, set authentication URL to:http://'.$_SERVER['SERVER_NAME'].str_replace('/index.php','',$_SERVER['SCRIPT_NAME']).'/topcmmchat/index/loginchat?username=%username%&password=%password%',
     		'style' => "display:none;",
     		'allowEmpty' => true,
     		'required' => false,
     ));
     
    // Element: fc_servertype
      $this->addElement('Radio', 'fc_servertype', array(
        'label' => 'Server Type:',
        'multiOptions' => array(
          '0' => '123FlashChat',
          '1' => '123PPVSoftware',
        ),
       	'onclick' => 'javascript:serverType(this.value)',
       	'value' => $row->fc_servertype,
      ));
      
    //Element: host
	  $this->addElement('Text', 'fc_server_host', array(
      'label' => 'Chat Server Host:',
      'allowEmpty' => true,
      'required' => false,
	  'value' => $row->fc_server_host,
	  'description' => 'Example:'.$_SERVER['SERVER_NAME'],
    ));
    
    //Element: port
	  $this->addElement('Text', 'fc_server_port', array(
      'label' => 'Chat Server Port:',
      'allowEmpty' => true,
      'required' => false,
      'value' => $row->fc_server_port,
	  'description' => 'Default:51127',
    ));
    
    //Element: port
	  $this->addElement('Text', 'fc_server_port_h', array(
      'label' => 'Chat Http Port:',
      'allowEmpty' => true,
      'required' => false,
      'value' => $row->fc_server_port_h,
	  'description' => 'Default:35555',
    ));
    
	//Element: Location
     $this->addElement('Text', 'fc_client_loc', array(
        'label' => 'Chat Client Location:',
        'value' => $row->fc_client_loc,
      ));

    // Element: fc_clienttype
      $this->addElement('Radio', 'fc_clienttype', array(
        'label' => 'Client Type:',
        'multiOptions' => array(
          '0' => 'Html Chat',
          '1' => 'Flash Chat',
        ),
       	'value' => $row->fc_clienttype,
      ));

    //Element: Chat Room
    $this->addElement('Text', 'fc_room', array(
      'label' => 'Chat Room:',
      'allowEmpty' => true,
      'required' => false,
      'value' => $row->fc_room,
    ));
    //Element: Show rooms list
    $this->addElement('Radio', 'fc_rooms', array(
        'label' => 'Show rooms list:',
        'multiOptions' => array(
          1 => 'Yes',
          0 => 'No',
        ),
        'value' => $row->fc_room_list,
      ));
    //Element: Show users list
    $this->addElement('Radio', 'fc_users', array(
        'label' => 'Show users list:',
        'multiOptions' => array(
          1 => 'Yes',
          0 => 'No',
        ),
        'value' => $row->fc_user_list,
      ));
      //Element: Full screen
      $this->addElement('Radio', 'fc_fullscreen', array(
        'label' => 'Full Screen:',
        'multiOptions' => array(
          1 => 'Yes',
          0 => 'No',
        ),
        'onclick' => 'javascript:fullScreen(this.value)',
        'value' => $row->fc_fullscreen,
      ));
      //Element: Chat Client Width
      $this->addElement('Text', 'fc_client_width', array(
        'label' => 'Chat Client Width:',
        'value' => $row->fc_client_width,
      ));
      //Element: Chat Client Height
      $this->addElement('Text', 'fc_client_height', array(
        'label' => 'Chat Client Height:',
        'value' => $row->fc_client_height,
      ));
      //Element: Chat Client Language
      $this->addElement('Select', 'fc_client_lang', array(
        'label' => 'Chat Client Language:',
        'required' => false,
        'multiOptions' => array(
			'*'  => 'Auto detect',
			'en' => 'English',
			'zh-CN'  => 'GB Chinese',
			'zh-TW'  => 'Big5 Chinese',
			'fr'  => 'French',
			'it'  => 'Italian',
			'de'  => 'German',
			'nl'  => 'Dutch',
			'hu'  => 'Hungarian',
			'es'  => 'Spanish',
			'hr'  => 'Croatian',
			'tr'  => 'Turkish',
			'ar'  => 'Arabic',
			'pt'  => 'Portuguese',
			'ru'  => 'Russian',
			'ko'  => 'Korean',
			'serbian'  => 'Serbian',
			'no'  => 'Norwegian',
			'ja'  => 'Japanese',
        ),
       'value' => $row->fc_client_lang,
      ));

      //Element: Chat Client Language
      $this->addElement('Text', 'languagenote', array(
        'label' => 'Chat Client Language:',
        'description' => 'Note: You can set the language in 123FlashChat Admin Panel -> Client Setting -> Language Setting',
        'allowEmpty' => true,
        'required' => false,
      ));
      //Element: Chat Client Skin
      $this->addElement('Select', 'fc_client_skin', array(
        'label' => 'Chat Client Skin:',
        'required' => false,
        'multiOptions' => array(
					'default' => 'Default',
					'green' => 'Green',
					'orange' => 'Orange',
					'red' => 'Red',
					'black' => 'Black',
					'beige' => 'Beige',
					'standard' => 'Standard',
					'clean' => 'Clean',
					'artistic' => 'Artistic',
        ),
        'value' => $row->fc_client_skin,
      ));
      //Element: Chat Client Skin
      $this->addElement('Text', 'skinnote', array(
        'label' => 'Chat Client Skin:',
        'description' => 'Note: You can set the skin in 123FlashChat Admin Panel -> Client Setting -> Skin'
      ));
      
	$this->addElement('Hidden', 'server_loc', array(
      'value' => $valid,
	  'id' => 'server_loc',
    ));
      //local hidden
       $this->addElement('Hidden', 'fc_server_local', array(
      'order' => 1,
      'value' => 0,
    ));
    //hidhost
    $this->addElement('Hidden', 'hidhost', array(
      'order' => 2,
      'value' => $row->fc_server_host,
    ));
    //hidport
    $this->addElement('Hidden', 'hidport', array(
     'order' => 3,
     'value' => $row->fc_server_port,
    ));
    //hidhttp
    $this->addElement('Hidden', 'hidhttp', array(
      'order' => 4,
      'value' => $row->fc_server_port_h,
    ));
    //serverval
    $this->addElement('Hidden', 'serverval', array(
      'order' => 5,
      'value' => $row->fc_extendserver,
    ));
    //lochidden
    $this->addElement('Hidden', 'lochidden', array(
      'order' => 6,
      'value' => $row->fc_client_loc,
    ));


  }
}