<?php
function isValidFilename($filename)
{
	if ($filename ==null)
	{
		return false;
	}
	else if (strlen(trim($filename)) == 0)
	{
		return false;
	}
	else if(strpos($filename, "//") !== false)
	{
		return false;
	}
	else if(strpos($filename, "/") !== false)
	{
		return false;
	}
	else if(strpos($filename,":") !== false)
	{
		return false;
	}
	else if(strpos($filename, "*") !== false)
	{
		return false;
	}
	else if(strpos($filename, "?") !== false)
	{
		return false;
	}
	else if(strpos($filename, "\"") !== false)
	{
		return false;
	}
	else if(strpos($filename, "<") !== false)
	{
		return false;
	}
	else if(strpos($filename, ">") !== false)
	{
		return false;
	}
	else if(strpos($filename, "|") !== false)
	{
		return false;
	}
	else if(strpos($filename, "..") !== false)
	{
		return false;
	}
}

function getImageInfo($filename)
{
	return @getimagesize($filename);
}

function getMimeType($filename)
{
	$imginfo = getImageInfo($filename);
	if(!empty($imginfo))
	{
		return $imginfo["mime"];
	}
	return false;
}

function getFileExt($filename)
{
	return strtolower(substr($filename, strrpos($filename, ".")));
}

function checkFileExtension($filename)
{
	$imginfo = getImageInfo($filename);
	$fileExt = getFileExt($filename);


	if(strtolower($fileExt) == ".jpg" || strtolower($fileExt) == ".jpeg")
	{
		if(!$imginfo && $imginfo["mime"] != "image/jpeg" && $imginfo["mime"]  != "image/pjpeg" && $imginfo["mime"]  != "image/jpg")
		{
			return false;
		}
	}

	if(strtolower($fileExt) == ".png")
	{
		if(!$imginfo && $imginfo["mime"] != "image/png")
		{
			return false;
		}
	}

	if(strtolower($fileExt) == ".bmp")
	{
		if(!$imginfo && $imginfo['mime'] != "image/bmp" && $imginfo['mime'] != "image/x-ms-bmp")
		{
			return false;
		}
	}

	if(strtolower($fileExt) == ".gif")
	{
		if(!$imginfo  && $imginfo['mime'] != "image/gif" )
		{
			return false;
		}
	}
}

function calPercent($getwidth,$getheight,$width,$height)
{
	$rate1 = $width/$getwidth + 0.1;
	$rate2 = $height/$getheight + 0.1;
	$rate = ($rate1 > $rate2) ? $rate1 : $rate2;
	return $rate;
}

function resizeImage($fileName,$im,$imginfo,$rate)
{
	list($width, $height) = getimagesize($fileName);
	$newWidth =  $width/$rate;
	$newHeight = $height/$rate;

	$thumb = imagecreatetruecolor($newWidth, $newHeight);
	imagecopyresized($thumb, $im, 0, 0, 0, 0, $newWidth, $newHeight, $width, $height);
	return $thumb;
}

//anthony
function resizeImageTwo($fileName, $new_width ,$new_height){
	list($width, $height) = getImageSize($fileName);
    $image_d = imageCreateTrueColor ($new_width, $new_height);
    $image_s = imagecreatefromjpeg ($fileName);
    imageCopyResampled ($image_d, $image_s, 0, 0, 0, 0,
                        $new_width, $new_height, $width, $height);
	$aa = 'aa.jpg';
   	header ('Content-type: image/jpeg');
    imageJPEG($image_d, $aa, 99);
    return $aa;
}

function uploadBinaryFiles($filename, $data, $fileid, $table)
{
	$file = @fopen($filename, "w");
	@fwrite($file, $data);
	@fclose($file);
	$img_size = ceil(filesize($filename)/1000)."k";
	$loginstable = Engine_Api::_()->getDbtable('logins', 'user');
	$loginsuser = $loginstable->select()->where('login_id = ?', $_SESSION['login_id'])->where('login_id = ?', $_SESSION['login_id']);
	$userlogin = $loginstable->fetchRow($loginsuser);
	$user = Engine_Api::_()->user()->getUser($userlogin->email);

	$actionstable = Engine_Api::_()->getDbtable('actions', 'activity');
	$action = $actionstable->select()->order('action_id DESC')->limit(1);
	$actionid = $actionstable->fetchRow($action);
//	file_put_contents('c://aaa.txt', $action);
//	return true;

	if(file_exists($filename))
	{
		$imginfo = getImageInfo($filename);
		if(!$imginfo && $imginfo["mime"] != "image/jpeg" && $imginfo["mime"]  != "image/pjpeg" && $imginfo["mime"]  != "image/jpg")
		{
			@unlink($filename);
			return false;
		}
		else
		{
			$name = $_GET['fn'];
			if($fileid->file_id < 10){
				$foldid = "0" . ($fileid->file_id + 1);
			}else{
				$foldid = $fileid->file_id + 1;
			}

			if($fileid->file_id < 10){
				$filename1 = "000" . $fileid->file_id;
			}else if($fileid->file_id < 100 && $fileid->file_id > 10){

				$filename1 = "00" . $fileid->file_id;

			}else if($fileid->file_id < 1000 && $fileid->file_id > 100){
				$filename1 = "0" . $fileid->file_id;
			}else{
				$filename1 = $fileid->file_id;
			}

			$img_end = substr($name,strrpos($name, "."));
			$filename2 = $filename1 . "_610b" . $img_end;
			$filename3 = $filename1 . "_5f8c" . $img_end;
			$filename4 = $filename1 . "_4b83" . $img_end;
			$filename5 = $filename1 . "_9c94" . $img_end;
			$foldid1 = $foldid . "a";
			$foldid2 = $foldid . "b";
			$foldid3 = $foldid . "c";
			$foldid4 = $foldid . "d";




			if(!is_dir(APPLICATION_PATH . "/public/user/" . $foldid1 . "a"))
			{
				mkdir (APPLICATION_PATH . "/public/user/" . $foldid1 ."/", 0700);
			}
			if(!is_dir(APPLICATION_PATH . "/public/user/" . $foldid2 . "a"))
			{
				mkdir (APPLICATION_PATH . "/public/user/" . $foldid2 ."/", 0700);
			}
			if(!is_dir(APPLICATION_PATH . "/public/user/" . $foldid3 . "a"))
			{
				mkdir (APPLICATION_PATH . "/public/user/" . $foldid3 ."/", 0700);
			}
			if(!is_dir(APPLICATION_PATH . "/public/user/" . $foldid4 . "a"))
			{
				mkdir (APPLICATION_PATH . "/public/user/" . $foldid4 ."/", 0700);
			}


			$file = @fopen(APPLICATION_PATH . "/public/user/".$foldid1 ."/".$filename2, "w");
			@fwrite($file, $data);
			@fclose($file);

			$aa = resizeImageTwo($filename,200,129);
			copy($aa, APPLICATION_PATH . "/public/user/".$foldid2 ."/".$filename3);

			$aa = resizeImageTwo($filename,48,31);
			copy($aa, APPLICATION_PATH . "/public/user/".$foldid3 ."/".$filename4);

			$aa = resizeImageTwo($filename,48,48);
			copy($aa, APPLICATION_PATH . "/public/user/".$foldid4 ."/".$filename5);
			$time =  date('Y-m-d h:i:s');
			$insertpath1 = "/public/user/".$foldid1 ."/".$filename2;
			$insertpath2 = "/public/user/".$foldid2 ."/".$filename3;
			$insertpath3 = "/public/user/".$foldid3 ."/".$filename4;
			$insertpath4 = "/public/user/".$foldid4 ."/".$filename5;
			$mime = explode("/", $imginfo["mime"]);
			$imgend = str_replace('.', '',$img_end);
			$parent_file_id = $fileid->file_id + 1;
			$fileid1 = $fileid->file_id-3;
			$fileid2 = $fileid->file_id-2;
			$fileid3 = $fileid->file_id-1;
			$where1 = array('file_id = ?' => $fileid1, 'user_id = ?' => $user->user_id);
			$where2 = array('file_id = ?' => $fileid2, 'user_id = ?' => $user->user_id);
			$where3 = array('file_id = ?' => $fileid3, 'user_id = ?' => $user->user_id);
			$where4 = array('file_id = ?' => $fileid->file_id, 'user_id = ?' => $user->user_id);file_put_contents("c:\\adcs.txt", $where1);
			$table->update(array(
				'creation_date' => $time,
				'modified_date' => $time,
				'storage_path' => $insertpath1,
				'extension' => $imgend,
				'name' => $name,
				'mime_major' => $mime[0],
				'mime_minor' => $mime[1],
			), $where1);
			$table->update(array(
				'creation_date' => $time,
				'modified_date' => $time,
				'storage_path' => $insertpath2,
				'extension' => $imgend,
				'name' => $name,
				'mime_major' => $mime[0],
				'mime_minor' => $mime[1],
			), $where2);

			$table->update(array(
				'creation_date' => $time,
				'modified_date' => $time,
				'storage_path' => $insertpath3,
				'extension' => $imgend,
				'name' => $name,
				'mime_major' => $mime[0],
				'mime_minor' => $mime[1],
			), $where3);

			$table->update(array(
				'creation_date' => $time,
				'modified_date' => $time,
				'storage_path' => $insertpath4,
				'extension' => $imgend,
				'name' => $name,
				'mime_major' => $mime[0],
				'mime_minor' => $mime[1],
			), $where4);
			return true;
		}


	}
	return false;
}

function addSlash($path)
{
	if(!empty($path))
	{
		$temp = strrev($path);
		if(substr($temp,0,1) != "/" || substr($temp,0,1) != "\\")
		{
			if(false !== strpos($temp, "/"))
			{
				$path .= "/";
			}
			elseif(false !== strpos($temp, "\\"))
			{
				$path .= "\\";
			}
			else
			{
				$path .= "/";
			}
		}
	}
	return $path;
}


function compressimage($file)
{
	if($_GET['cp'] != 1)
	{
		return false;
	}

	$quality    = (!empty($_GET['q']))?$_GET['q']*100:"50";
	$getwidth   = (!empty($_GET['w']))?$_GET['w']:"";
	$getheight  = (!empty($_GET['h']))?$_GET['h']:"";

	$imginfo = getImageInfo();

	list($width, $height) = $imginfo;


	if((!empty($getwidth) && !empty($getheight)) && ($width > $getwidth || $height > $getheight))
	{
		$rate = calPercent($getwidth,$getheight,$width,$height);
	}

	if($imginfo['mime'] == "image/gif")
	{
		$im = imagecreatefromgif($file);
		if(!empty($rate) && $rate > 0)
		{
			$im = resizeImage($file,$im,$imginfo,$rate);
		}
	}
	else if($imginfo['mime'] == "image/png")
	{
		$im=imagecreatetruecolor($width,$height);
		$bg = imagecolorallocate ( $im, 255, 255, 255 );
		imagefill ( $im, 0, 0, $bg );
		$srcimage=imagecreatefrompng($file);

		imagecopyresampled($im,$srcimage,0,0,0,0, $width,$height,$width,$height);

		if(!empty($rate) && $rate > 0)
		{
			$im = resizeImage($file,$im,$imginfo,$rate);
		}
	}
	else if($imginfo['mime'] == "image/jpg" || $imginfo['mime'] == "image/jpeg")
	{

		$im = imagecreatefromjpeg($file);
		if(!empty($rate) && $rate > 0)
		{
			$im = resizeImage($file,$im,$imginfo,$rate);
		}
	}
	else if($imginfo['mime'] == "image/bmp" || $imginfo['mime'] == "image/x-ms-bmp")
	{
		require_once APPLICATION_PATH . '/application/modules/Topcmmchat/uploadavatar/bmp.php';
		$bmp = new bmp();
		$im =  $bmp->imagecreatefrombmp($file);
		if(!empty($rate) && $rate > 0)
		{
			$im = resizeImage($file,$im,$imginfo,$rate);
		}
	}

	imagejpeg($im,$file,$quality);
}

function uploadfiles($file, $fileName)
{
	global $UPLOAD_SUCCESS,$UPLOAD_ERROR;
	if (@move_uploaded_file($file, $fileName))
	{
		echo $UPLOAD_SUCCESS;
	}
	else
	{
		echo $UPLOAD_ERROR;
	}
}

function getAvatarUploadPath($filepath)
{
	$filepath = addSlash($filepath);

	if(isset($_GET['ulv']))
	{
		$ulv = $_GET['ulv'];
		switch($ulv)
		{
			case "0":
				return getAvatarUploadPathByRole($filepath, "member");
				break;
			case "1":
			  return getAvatarUploadPathByRole($filepath, "guest");
			  break;
		}
	}

	return false;
}

function getAvatarUploadPathByRole($filepath, $role)
{

	$path = $filepath."upload/".$role."/";
	if(!file_exists($path))
	{
		if(!mkdir($path))
		{
			return false;
		}
	}

	return $path;
}
?>